/*
**  LinVPN 1.0
**  Copyright (C) 2001 Alex Fiori <alex@linuxbr.com>
**
**  This program is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2
**  of the License, or (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307
**  USA, or contact Alex Fiori <alex@linuxbr.com>
*/

#include <stdio.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>

/* kernel */
#include <linux/if.h>
#include <linux/sockios.h>

/* o_O */
#include "vpn-base.h"

char *vpn_ifaddr (const char *ifname)
{
	int fd;
	static char *addr;

	struct ifreq ifr;
	struct sockaddr_in *s;
	
	ifr.ifr_addr.sa_family = AF_INET;
	strncpy (ifr.ifr_name, ifname, sizeof (ifr.ifr_name));

	if ((fd = socket (AF_INET, SOCK_DGRAM, 0)) < 0) return NULL;
	if (ioctl (fd, SIOCGIFADDR, (char *) &ifr) < 0) return NULL;
	
	s = (struct sockaddr_in *) &ifr.ifr_addr;
	if ((addr = inet_ntoa (s->sin_addr)) == NULL) return NULL;
	
	close (fd);
	return addr;
}
